from xml.dom import minidom
import urllib2

BASE_URL = 'http://dir.xiph.org/yp.xml'
CHUNK_SIZE = 65536

str_list = []
xml = ''

response = urllib2.urlopen(BASE_URL);

while 1:
  chunk = response.read(CHUNK_SIZE)
  if not chunk: break
  str_list.append(chunk)

response.close()

xml = ''.join(str_list)

dom = minidom.parseString(xml)

entries = dom.getElementsByTagName("entry")

for entry in entries:
  server_name_objects = entry.getElementsByTagName("server_name")
  for server_name_object in server_name_objects:
    server_name = getText(server_name_object.childNodes)

  genre_objects = entry.getElementsByTagName("genre")
  for genre_object in genre_objects:
    genre_name = getText(genre_object.childNodes)

  listen_url_objects = entry.getElementsByTagName("listen_url")
  for listen_url_object in listen_url_objects:
    listen_url = getText(listen_url_object.childNodes)

  bitrate_objects = entry.getElementsByTagName("bitrate")
  for bitrate_object in bitrate_objects:
    bitrate = getText(bitrate_object.childNodes)

  # At this ponit you have all the data for the station:
  #
  # server_name - the server's name
  # genre_name - the genre (one or more keywords)
  # listen_url - the URL of the stream
  # bitrate - the bitrate of the stream
  #
  # You can now store these, or build hashes from them etc. 
  # To play the URL, just feed the listen_url to the player




